
% ~~~~
% displaystc.m: reads BrainVoyager *.fmr, displays it's *.stc data higher than FMR version 5
% Saves img of datavol in subfolder.
% Usage: load in Matlab, press 'Run'
% HB 2011
% ~~~~

volnr = 1        % volume number to be shown (starts counting at 1)
figuresofall = 0 % if 1: create *.jpg from each volume (takes long!); else put '0'

% ~~~~

[FileName, PathName] = uigetfile('*.fmr')
fmrname = [PathName FileName]
[pathstr, name, ext, versn] = fileparts(fmrname)
fmrFile = textread(fmrname,'%s','delimiter',' ')
for i=1:length(fmrFile);
    line = fmrFile{i};
    if ~isempty(strfind(line, 'NrOfSlices:'))
        dimz = str2num(fmrFile{i+1});
    end
    if ~isempty(strfind(line, 'NrOfVolumes:'))
        dimt = str2num(fmrFile{i+1});
    end
    if ~isempty(strfind(line, 'Prefix:'))
        stcstr = fmrFile{i+1}(2:end-1)
        stcname = [pathstr filesep stcstr '.stc'];
    end
    if ~isempty(strfind(line, 'NCols:'))
        dimx = str2num(fmrFile{i+1});
    end
    if ~isempty(strfind(line, 'NRows:'))
        dimy = str2num(fmrFile{i+1});
    end

end

fid=fopen(stcname,'rb');
data = fread(fid, dimx*dimy*dimz*dimt*4, 'float32');
fclose(fid);
if dimt > 1
    stcdata = reshape(data, dimx, dimy, dimt, dimz);
    permute(stcdata, [1 2 4 3]);
else
    stcdata = reshape(data, dimx, dimy, dimz);
end

h = figure;
if dimz > 63
    nrofrows = 8;
    nrofcols = 8;
elseif dimz > 36
    nrofrows = 7;
    nrofcols = 7;
elseif dimz > 25
    nrofrows = 6;
    nrofcols = 6;
else
    nrofrows = 5;
    nrofcols = 5;
end
if dimt > 1
    for i=1:dimz
    subplot(nrofrows,nrofcols,i); 
    imagesc(stcdata(:,:,volnr,i));
end
else
    for i=1:dimz
    subplot(nrofrows,nrofcols,i); 
    imagesc(stcdata(:,:,i));
end
end

colormap gray;
colorbar
saveas(h,[pathstr filesep name '_stcdata' num2str(volnr) '.jpg'])

figure;
 imagesc(stcdata(:,:,1));
 colormap gray;
colorbar
 



if figuresofall
mkdir(pathstr,[name '_imgs'])
    for j=1:dimt
        h = figure;
        for i=1:dimz
            subplot(nrofrows,nrofcols,i); imagesc(stcdata(:,:,j,i));
        end
        colormap gray;
        saveas(h,[pathstr filesep [name '_imgs'] filesep name '_stcdata' num2str(j) '.jpg'])
        close(h);
    end
end

%[n,xout] = hist(...) 